/**
 * @file userSettings.h
 *
 * @section LICENSE
 *
 * This file is part of receptiongreet.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *  @date 20.Aug 2011
 *  @author Pascal Audoux
 */
#ifndef USERSETTINGS_H
#define USERSETTINGS_H

#include <QString>


class userSettings
{
public:
        enum DisplayOptionType {
            DISPLAY_RULE = 0,
            DISPLAY_COORD,
            DISPLAY_ZONE,
            DISPLAY_SHAPE,
            LAST_RENDER
        };

        static bool getDisplayOption( DisplayOptionType option );

        static void setDisplayOption( DisplayOptionType option, bool state );
        static void setOtherOption( DisplayOptionType option, QString state );
	
	
	
protected:
        userSettings() {}
};

#endif // USERSETTINGS_H

